var timerInterval = null;
var info1 = "";
var info2 = "";
var info3 = "";
var info4 = "";

function onshow () {
	if (timerInterval == null) {
		startSecondHandTimer();
	}
}

function onhide () {
	
}

function showbackside(event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	onhide();
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	


	document.getElementById('fliprollie').style.display = 'none';
}


function doneClicked() {
		var front = document.getElementById("front");
		var back = document.getElementById("behind");

		if (window.widget)
				widget.prepareForTransition("ToFront");


		front.style.display="block";
		back.style.display="none";

		setTimeout ('flipitback();', 0);
		onshow();

}


function flipitback()
{
	updateTime(false);
	if (window.widget)
		setTimeout("widget.performTransition();", 0);
}


if (window.widget) {
	widget.onhide = onhide;
	widget.onshow = onshow;
}




var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};


//	Returns val if min < val < max
//	Returns min if val <= min
//	Returns max if val >= max

function limit_3 (val, min, max)
{
	return val < min ? min : (val > max ? max : val);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
}


function mousemove (event)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer	= null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer	= null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


function doneMouseUp(event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("behind");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	// Einstellungen Speichern:
	widget.setPreferenceForKey(document.getElementById("starto").value, createkey("starto"));
	widget.setPreferenceForKey(document.getElementById("zielo").value, createkey("zielo"));
	neuFelder();
	

	
	front.style.display="block";
	back.style.display="none";
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	backside = false;
	loadData();
}

function onremove ()
{
	if (window.widget)
	{
		// Einstellungen vergessen, wenn gelscht:
		widget.setPreferenceForKey (null, createkey("starto"));
		widget.setPreferenceForKey (null, createkey("zielo"));
	}
}

if (window.widget)
{
	widget.onremove = onremove;
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function createkey(key)
{
	return widget.identifier + "-" + key;
}

// Lade Daten von SBB fr Anzeige:

var download_uniqueid = 1;

if (window.widget){
	widget.onshow = onshow;
}

function setup(){
	// Sprache Laden:
	setHTML("source",getLocalizedString("Daten von"));
	setHTML("info",getLocalizedString("Lade Daten..."));
	setHTML("startort",getLocalizedString("Startort:"));
	setHTML("zielort",getLocalizedString("Zielort:"));
	setHTML("validate",getLocalizedString("berprfen"));
	setHTML("delete",getLocalizedString("Lschen"));
	// Schauen ob Einstellungen schon vorhanden sind:
	var s = widget.preferenceForKey(createkey("starto"));
	if(!s){
		showbackside(event);
		return;
	};
	setHTML("start","<input id=\"starto\" type=\"search\">")
	setHTML("ziel","<input id=\"zielo\" type=\"search\">")
	document.getElementById("starto").value = widget.preferenceForKey(createkey("starto"));
	document.getElementById("zielo").value = widget.preferenceForKey(createkey("zielo"));
	loadData();
}

function getLocalizedString(key){
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}
	return key;
}

function onshow() {
	loadData();
}

function loadData() {
	
	if (window.widget) {
		var front = document.getElementById("info");
		front.style.display= "block";
		var startOrt = escape(document.getElementById("starto").value);
		var zielOrt = escape(document.getElementById("zielo").value);
		var url = "http://fahrplan.sbb.ch/bin/query.exe?REQ0JourneyStopsS0G=" + startOrt + "&REQ0JourneyStopsZ0G=" + zielOrt + "&start=%26%23xBB%3B%26nbsp%3BVerbindung+suchen&REQ0JourneyStopsS0ID=&REQ0JourneyStopsZ0ID=&REQ0JourneyStops1.0A=1&REQ0JourneyStops1.0G=&REQ0JourneyStopsS0A=7&REQ0JourneyStopsZ0A=7";
		download_async_text(parsePage,url);
	}

	function parsePage(success, text){
		if (!success){
			setHTML("info",getLocalizedString("Fehler"));
			return;
		}
		
		detailInfo(text);
		var start = text.indexOf("<table cellspacing=\"0\" class=\"hafas-content hafas-tp-result-overview\">");
		var ende = text.indexOf("</table>",start);
		var data = text.substring(start,ende);
		start = data.indexOf("</tr>");
		ende = data.length;
		data = data.substring(start,ende);
		var s = data.split("<tr class=\"zebra-row-");
		var table = "";
		var progress = "";
		var counter = 0;
		for (var i = 1; i < s.length; i += 2){
			progress += ".";
			counter++;
			var tmpStart = s[i]; // Start Ort
			var tmpZiel = s[i+1]; // Ziel Ort
			
			// Suche Location:
			start = tmpStart.indexOf("<td headers=\"location\" class=\"result\" nowrap=\"nowrap\">");
			ende = tmpStart.indexOf("</td>",start);
			//alert("Verbindung: " +  i);
			var startOrt = clearLocation(tmpStart.substring(start,ende));
			start = tmpZiel.indexOf("<td headers=\"location\" class=\"result\" nowrap=\"nowrap\">");
			ende = tmpZiel.indexOf("</td>",start);
			var zielOrt = clearLocation(tmpZiel.substring(start,ende));
			
			// Zeiten Suchen:
			var sk = "<td headers=\"time\" class=\"result\" width=\"1\">ab&nbsp;</td>\n<td headers=\"time\" class=\"result\" width=\"1\">";
			start = tmpStart.indexOf(sk) + sk.length;
			ende = tmpStart.indexOf("</td>",start);
			zeitAb = tmpStart.substring(start,ende);
			
			var sk = "<td headers=\"time\" class=\"result\">an&nbsp;</td>\n<td headers=\"time\" class=\"result\">";
			start = tmpZiel.indexOf(sk) + sk.length;
			ende = tmpZiel.indexOf("</td>",start);
			zeitAn = tmpZiel.substring(start,ende);
			
			// Dauer:
			var sk = "<td headers=\"duration\" class=\"result\" nowrap rowspan=\"2\" valign=\"top\">";
			start = tmpStart.indexOf(sk) + sk.length;
			ende = tmpStart.indexOf("</td>",start);
			var dauer = tmpStart.substring(start,ende);
			
			// Umsteigen:
			var sk = "<td headers=\"changes\" class=\"result\" nowrap rowspan=\"2\" valign=\"top\">";
			start = tmpStart.indexOf(sk) + sk.length;
			ende = tmpStart.indexOf("</td>",start);
			var umst = "<span onClick=\"showDetail(" + counter + ");\">" + tmpStart.substring(start,ende) + "</span>";
			
			// Reise mit:
			var sk = "<td headers=\"products\" class=\"result\" nowrap=\"nowrap\" rowspan=\"2\" valign=\"top\">";
			start = tmpStart.indexOf(sk) + sk.length;
			ende = tmpStart.indexOf("</td>",start);
			var reise = tmpStart.substring(start,ende);
			
			// Daten abfllen:
			table += "<tr><td>" + zeitAb + "</td><td>" + zeitAn + "</td><td>" + dauer + "</td><td>" + umst + "</td><td>" + reise + "</td></tr>";
		}
		var kopf = "<table width=\"100%\"><tr><td><b>" + startOrt + "</b></td><td><b>" + zielOrt + "</b></td><td  width=\"35px\">" + getLocalizedString("Dauer") + "</td><td width=\"30px\">" + getLocalizedString("Umst.") + "</td><td width=\"55px\">" + getLocalizedString("Reise mit") + "</td></tr>";
		setHTML("data",kopf + table + "</table>");
		front.style.display= "none";
	}
}

function download_async_text(callback, url){
	Req = new XMLHttpRequest();
	Req.onreadystatechange = mycallback;
	download_uniqueid++;
	Req.open("GET", url + "&uniqueid=" + download_uniqueid, true);
	Req.send(null);

	function mycallback(){
		if (Req.readyState != 4) return;
		
		if (Req.status == 200)
		{
			callback(true, Req.responseText);
		}
		else
			callback(false, Req.status + ": " + Req.statusText);
	}
}

function setHTML(id, html){
	document.getElementById(id).innerHTML = html;
}

function clearLocation(data){
	var start = data.indexOf("</a>&nbsp;<a href=") + 7;
	start = data.indexOf(">",start) + 1;
	var ende = data.indexOf("</a>",start);
	return data.substring(start,ende);
}


// Haltestellen prfen:


function validate() {
	var startOrt = escape(document.getElementById("starto").value);
	var zielOrt = escape(document.getElementById("zielo").value);
	var url = "http://fahrplan.sbb.ch/bin/query.exe?REQ0JourneyStopsS0G=" + startOrt + "&REQ0JourneyStopsZ0G=" + zielOrt + "&start=%26%23xBB%3B%26nbsp%3BVerbindung+suchen&REQ0JourneyStopsS0ID=&REQ0JourneyStopsZ0ID=&REQ0JourneyStops1.0A=1&REQ0JourneyStops1.0G=&REQ0JourneyStopsS0A=7&REQ0JourneyStopsZ0A=7";
	download_async_text(parseValidate,url);
}

function parseValidate(success, text){
	if (!success){
		return;
	}
	
	// Schauen ob Ort Popups vorhanden sind:
	var sOrt = extractData(text,"<!--  section Von: - begin -->","<!--  section  - end -->");
	var zOrt = extractData(text,"<!--  section Nach: - begin -->","<!--  section  - end -->");
	if(sOrt == -1 && zOrt == -1){
		setHTML("sOrt",getLocalizedString("Existiert"));
		setHTML("zOrt",getLocalizedString("Existiert"));
	}else{
		// Schauen ob es Startort gibt:
		if(sOrt.indexOf("<span class=\"bold\">") != -1){
			setHTML("sOrt",getLocalizedString("Existiert"));
		}else{
			setHTML("sOrt",getLocalizedString("Existiert nicht"));
			var ex = extractOptions(sOrt);
			setHTML("start","<select id=\"starto\">" + ex + "</select>");
		}
		// Schauen ob es Zielort gibt:
		if(zOrt.indexOf("<span class=\"bold\">") != -1){
			setHTML("zOrt",getLocalizedString("Existiert"));
		}else{
			setHTML("zOrt",getLocalizedString("Existiert nicht"));
			var ex = extractOptions(zOrt);
			setHTML("ziel","<select id=\"zielo\">" + ex + "</select>");
		}
	}
}

function extractData(txt,startTxt,endTxt){
	// Gibt den Text zurck, der in txt zwischen den Vorkommen
	// von startTxt und endTxt liegt.
	// Wenn der gesuchte String nicht vorhanden ist wird -1 zurckgegeben
	return extractData(txt,startTxt,endTxt,0);
}

function extractData(txt,startTxt,endTxt,start){
	// Gibt den Text zurck, der in txt zwischen den Vorkommen
	// von startTxt und endTxt liegt.
	// Wenn der gesuchte String nicht vorhanden ist wird -1 zurckgegeben
	start = txt.indexOf(startTxt,start);
	if(start < 0){
		return "-1";
	}
	ende = txt.indexOf(endTxt,start);
	return txt.substring(start	+ startTxt.length,ende);
}

function extractOptions(data){
	var daten = "";
	var i = 0;
	var s = data.split("<option value=");
	for (var i = 1; i < s.length; i += 2) {
		var temp = s[i];
		var start = temp.indexOf(">");
		// In der Liste stehen die Haltestellen mit Anmerkungen in [] Klammern
		// Diese drfen aber nicht in der Abfrage sein, da sonst nicht der
		// Richtige Ort gefunden wird. Darum filtern wir die Optionen raus:
		var ende = temp.indexOf("[",start);
		var data = temp.substring(start+1,ende);
		daten = daten + "<option value=\"" + data + "\">" + data + "</option>";
	}
	return daten;
}

function neuFelder (event){
	setHTML("start","<input id=\"starto\" type=\"search\">")
	setHTML("ziel","<input id=\"zielo\" type=\"search\">")
	document.getElementById("starto").value = widget.preferenceForKey(createkey("starto"));
	document.getElementById("zielo").value = widget.preferenceForKey(createkey("zielo"));
	setHTML("sOrt","");
	setHTML("zOrt","");
}

// Parse genaue Verbindungsdaten:

function showDetail(id){
	if(id == 1){
		var d = info1;
	}else if(id == 2){
		var d = info2;
	}else if(id == 3){
		var d = info3;
	}else{
		var d = info4;
	}
	
	setHTML("ddata",d);
	document.getElementById("detail").style.display="block";
}

function closeInfo(){
	document.getElementById("detail").style.display="none";
}

function detailInfo(data){
	// <table summary="Details - Verbindung 1"
	// bis </table
	var d1 = "<table summary=\"Details - Verbindung 1\" cellspacing=\"0\" width=\"100%\" class=\"hac_detail\">";
	var d2 = "<table summary=\"Details - Verbindung 2\" cellspacing=\"0\" width=\"100%\" class=\"hac_detail\">";
	var d3 = "<table summary=\"Details - Verbindung 3\" cellspacing=\"0\" width=\"100%\" class=\"hac_detail\">";
	var d4 = "<table summary=\"Details - Verbindung 4\" cellspacing=\"0\" width=\"100%\" class=\"hac_detail\">";
	
	var ende = "</table";
	info1 = parseDetail(extractData(data,d1,ende));
	info2 = parseDetail(extractData(data,d2,ende));
	info3 = parseDetail(extractData(data,d3,ende));
	info4 = parseDetail(extractData(data,d4,ende));
}

function parseDetail(data){
	// Parste die genauen Verbindungsdaten:
	
	// Erste Zeile der Tabelle kann bersprungen werden (Header)
	start = data.indexOf("<tr>") + 5;
	start = data.indexOf("<tr>",start) + 5;
	
	data = data.substring(start);
	s = data.split("<tr>");
	table = "";
	for (var i = 0; i < s.length -1; i++){
		// Durch jede Zeile der Tabelle durchgehen:
		t = s[i];

		// Icon //"class=\"stop-station-icon"
		start = t.indexOf("<td");
		start = t.indexOf(">",start) + 1;
		ende = t.indexOf("</td>",start);
		
		// Station // "class=\"stop-station"
		start = t.indexOf("<td",ende);
		start = t.indexOf(">",start) + 1;
		ende = t.indexOf("</td>",start);
		stops = t.substring(start,ende);
		
		// Date //"class=\"date"
		start = t.indexOf("<td",ende);
		start = t.indexOf(">",start) + 1;
		ende = t.indexOf("</td>",start);
		date = t.substring(start,ende);
		
		// TimeArt //"class=\"time prefix"
		start = t.indexOf("<td",ende);
		start = t.indexOf(">",start) + 1;
		ende = t.indexOf("</td>",start);
		timeArt = t.substring(start,ende);
		
		// Time // "class=\"time",ende
		start = t.indexOf("<td",ende);
		start = t.indexOf(">",start) + 1;
		ende = t.indexOf("</td>",start);
		time = t.substring(start,ende);
		
		// Platform //"class=\"platform"
		start = t.indexOf("<td",ende);
		start = t.indexOf(">",start) + 1;
		ende = t.indexOf("</td>",start);
		platform = t.substring(start,ende);
		
		// Products // "class=\"products"
		start = t.indexOf("class=\"products");
		if(start > -1){
			start = t.indexOf(">",start) + 1;
			ende = t.indexOf("</td>",start);
			products = t.substring(start,ende);
		}else{
			products = "";
		};
		
		// Remarks
		start = t.indexOf("class=\"remarks");
		if(start > -1){
			start = t.indexOf(">",start) + 1;
			ende = t.indexOf("</td>",start);
			remarks = t.substring(start,ende);
		}else{
			remarks = "";
		}
		
		// Ortsname krzen wenn zu lange:
		stops = removeTags(stops);
		if(stops.length > 15){
			stops = stops.substring(0,15) + "...";
		}
		table = table + "<tr><td>" + stops + "</td><td>" + date + "</td><td>" + timeArt + "</td><td>" + time + "</td><td>" + platform + "</td><td>" + removeLinks(products) + "</td><td>" + remarks + "</td></tr>";
	}
	table = "<table class\"infotable\"><tr><td>Ort</td><td>Datum</td><td>Art</td><td>Zeit</td><td>Gleis</td><td>Reise</td><td>Bem.</td></tr>" + table + "</table>";
	return table;
}

function removeTags(data){
	start = data.indexOf(">") + 1;
	if(start == -1){
		start = 0;
	}
	ende = data.indexOf("<",start);
	return data.substring(start,ende);
}

function removeLinks(data){
	start = data.indexOf("<a") + 1;
	if(start == -1){
		return data;
	}
	start = data.indexOf(">",start) + 1;
	ende = data.indexOf("</a>",start);
	return data.substring(start,ende);
}